{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
(*===================================================================*)
(*                           GRAFTABL.PAS                            *)
(*              Copyright (C) 1993 te-wi Verlag, Mnchen             *)
(* Die Unit mu nach GRAPH eingebunden sein:                         *)
(*   USES Graph, Graftabl, ... ;                                     *)
(*-------------------------------------------------------------------*)
(* Mit GrafTable[xxx,y] := $zz ... kann der Zeichensatz nachtrglich *)
(* manipuliert werden, so knnen fr den Grakmodus der CGA/HGC-Karte *)
(* neue Zeichen definiert werden.                                    *)
(*                                                                   *)
(* Aufbau der 8x8-Bit-Maske:                                         *)
(*                       Ŀ                                         *)
(*  0.  $3C =  00111100                                             *)
(*  1.  $66 =  01100110                                             *)
(*  2.  $60 =  01100000                                             *)
(*  3.  $66 =  01100110     #128 =                                *)
(*  4.  $3C =  00111100                                             *)
(*  5.  $0C =  00001100                                             *)
(*  6.  $06 =  00000110                                             *)
(*  7.  $3C =  00111100                                             *)
(*                                                                *)
(*                                                                   *)
(*-------------------------------------------------------------------*)
(* In der aktuellen Version wird die Routine nur dann verwendet,     *)
(* wenn der Grafikzeichensatz (Graftabl, EGA/VGA) noch nicht         *)
(* installiert ist (Interruptvektor $1F zeigt auf Segment $0000).    *)
(* Wenn Zeichen modifiziert werden, mu die Testroutine entfernt     *)
(* werden.                                                           *)
(*===================================================================*)

UNIT GrafTabl;

INTERFACE

TYPE
  BitMap  = ARRAY[0..7] OF BYTE;
  CharSet = ARRAY[128..255] OF BitMap;

CONST
  GrafTable: Charset = (
   (* Maske der ASCII-Zeichen von 128 bis 255 fr den Grafikmodus.   *)
   (* Die Tabelle ersetzt das Programm GRAFTABL fr ein Programm     *)
   (* in das GrafTabl eingebunden ist, wenn dieses mit CGA/Hercules  *)
   (* luft. Bei EGA/VGA wird die Unit nicht bentigt, da der        *)
   (* Zeichensatz im Grafik-BIOS bereits vorhanden ist bei           *)
   (* ($C000:XXXX)                                                   *)
   (* Aufbau der Tabelle:                                            *)
   (* jede Zeile = 1 Zeichen,                                        *)
   (* 1. Zeichen = 1. Zeile..8. Zeichen = 8. Zeile                   *)
   (* der 8x8-Bitmaske.                                              *)
   (* Die Tabelle ist nur fr den Zeichensatz DefaultFont (Nr. 0)  *)
   (* wirksam, nicht fr die BGI-Vektor-Zeichenstze *.CHR)          *)
   ($3C, $66, $60, $66, $3C, $0C, $06, $3C), {#128}
   ($00, $66, $00, $66, $66, $66, $3F, $00), {#129}
   ($0E, $00, $3C, $66, $7E, $60, $3C, $00), {#130}
   ($7E, $C3, $3C, $06, $3E, $66, $3F, $00), {#131}
   ($66, $00, $3C, $06, $3E, $66, $3F, $00), {#132}
   ($70, $00, $3C, $06, $3E, $66, $3F, $00), {#133}
   ($18, $18, $3C, $06, $3E, $66, $3F, $00), {#134}
   ($00, $00, $3C, $60, $60, $3C, $06, $1C), {#135}
   ($7E, $C3, $3C, $66, $7E, $60, $3C, $00), {#136}
   ($66, $00, $3C, $66, $7E, $60, $3C, $00), {#137}
   ($70, $00, $3C, $66, $7E, $60, $3C, $00), {#138}
   ($66, $00, $38, $18, $18, $18, $3C, $00), {#139}
   ($7C, $C6, $38, $18, $18, $18, $3C, $00), {#140}
   ($70, $00, $38, $18, $18, $18, $3C, $00), {#141}
   ($63, $1C, $36, $63, $7F, $63, $63, $00), {#142}
   ($18, $18, $00, $3C, $66, $7E, $66, $00), {#143}
   ($0E, $00, $7E, $30, $3C, $30, $7E, $00), {#144}
   ($00, $00, $7F, $0C, $7F, $CC, $7F, $00), {#145}
   ($1F, $36, $66, $7F, $66, $66, $67, $00), {#146}
   ($38, $66, $00, $3C, $66, $66, $3C, $00), {#147}
   ($00, $66, $00, $3C, $66, $66, $3C, $00), {#148}
   ($00, $70, $00, $3C, $66, $66, $3C, $00), {#149}
   ($3C, $66, $00, $66, $66, $66, $3F, $00), {#150}
   ($00, $70, $00, $66, $66, $66, $3F, $00), {#151}
   ($60, $66, $00, $66, $66, $3E, $06, $7C), {#152}
   ($C3, $18, $3C, $66, $66, $3C, $18, $00), {#153}
   ($66, $00, $66, $66, $66, $66, $3C, $00), {#154}
   ($18, $18, $7E, $C0, $C0, $7E, $18, $18), {#155}
   ($1C, $36, $32, $78, $30, $73, $7E, $00), {#156}
   ($66, $66, $3C, $7E, $18, $7E, $18, $18), {#157}
   ($F8, $CC, $CC, $FA, $C6, $CF, $C6, $C7), {#158}
   ($0E, $1B, $18, $3C, $18, $18, $D8, $70), {#159}
   ($0E, $00, $3C, $06, $3E, $66, $3F, $00), {#160}
   ($1C, $00, $38, $18, $18, $18, $3C, $00), {#161}
   ($00, $0E, $00, $3C, $66, $66, $3C, $00), {#162}
   ($00, $0E, $00, $66, $66, $66, $3F, $00), {#163}
   ($00, $7C, $00, $7C, $66, $66, $66, $00), {#164}
   ($7E, $00, $66, $76, $7E, $6E, $66, $00), {#165}
   ($3C, $6C, $6C, $3E, $00, $7E, $00, $00), {#166}
   ($38, $6C, $6C, $38, $00, $7C, $00, $00), {#167}
   ($18, $00, $18, $30, $60, $66, $3C, $00), {#168}
   ($00, $00, $00, $7E, $60, $60, $00, $00), {#169}
   ($00, $00, $00, $7E, $06, $06, $00, $00), {#170}
   ($C3, $C6, $CC, $DE, $33, $66, $CC, $0F), {#171}
   ($C3, $C6, $CC, $DB, $37, $6F, $CF, $03), {#172}
   ($18, $18, $00, $18, $18, $18, $18, $00), {#173}
   ($00, $33, $66, $CC, $66, $33, $00, $00), {#174}
   ($00, $CC, $66, $33, $66, $CC, $00, $00), {#175}
   ($22, $88, $22, $88, $22, $88, $22, $88), {#176}
   ($55, $AA, $55, $AA, $55, $AA, $55, $AA), {#177}
   ($DB, $77, $DB, $EE, $DB, $77, $DB, $EE), {#178}
   ($18, $18, $18, $18, $18, $18, $18, $18), {#179}
   ($18, $18, $18, $18, $F8, $18, $18, $18), {#180}
   ($18, $18, $F8, $18, $F8, $18, $18, $18), {#181}
   ($36, $36, $36, $36, $F6, $36, $36, $36), {#182}
   ($00, $00, $00, $00, $FE, $36, $36, $36), {#183}
   ($00, $00, $F8, $18, $F8, $18, $18, $18), {#184}
   ($36, $36, $F6, $06, $F6, $36, $36, $36), {#185}
   ($36, $36, $36, $36, $36, $36, $36, $36), {#186}
   ($00, $00, $FE, $06, $F6, $36, $36, $36), {#187}
   ($36, $36, $F6, $06, $FE, $00, $00, $00), {#188}
   ($36, $36, $36, $36, $FE, $00, $00, $00), {#189}
   ($18, $18, $F8, $18, $F8, $00, $00, $00), {#190}
   ($00, $00, $00, $00, $F8, $18, $18, $18), {#191}
   ($18, $18, $18, $18, $1F, $00, $00, $00), {#192}
   ($18, $18, $18, $18, $FF, $00, $00, $00), {#193}
   ($00, $00, $00, $00, $FF, $18, $18, $18), {#194}
   ($18, $18, $18, $18, $1F, $18, $18, $18), {#195}
   ($00, $00, $00, $00, $FF, $00, $00, $00), {#196}
   ($18, $18, $18, $18, $FF, $18, $18, $18), {#197}
   ($18, $18, $1F, $18, $1F, $18, $18, $18), {#198}
   ($36, $36, $36, $36, $37, $36, $36, $36), {#199}
   ($36, $36, $37, $30, $3F, $00, $00, $00), {#200}
   ($00, $00, $3F, $30, $37, $36, $36, $36), {#201}
   ($36, $36, $F7, $00, $FF, $00, $00, $00), {#202}
   ($00, $00, $FF, $00, $F7, $36, $36, $36), {#203}
   ($36, $36, $37, $30, $37, $36, $36, $36), {#204}
   ($00, $00, $FF, $00, $FF, $00, $00, $00), {#205}
   ($36, $36, $F7, $00, $F7, $36, $36, $36), {#206}
   ($18, $18, $FF, $00, $FF, $00, $00, $00), {#207}
   ($36, $36, $36, $36, $FF, $00, $00, $00), {#208}
   ($00, $00, $FF, $00, $FF, $18, $18, $18), {#209}
   ($00, $00, $00, $00, $FF, $36, $36, $36), {#210}
   ($36, $36, $36, $36, $3F, $00, $00, $00), {#211}
   ($18, $18, $1F, $18, $1F, $00, $00, $00), {#212}
   ($00, $00, $1F, $18, $1F, $18, $18, $18), {#213}
   ($00, $00, $00, $00, $3F, $36, $36, $36), {#214}
   ($36, $36, $36, $36, $FF, $36, $36, $36), {#215}
   ($18, $18, $FF, $18, $FF, $18, $18, $18), {#216}
   ($18, $18, $18, $18, $F8, $00, $00, $00), {#217}
   ($00, $00, $00, $00, $1F, $18, $18, $18), {#218}
   ($FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF), {#219}
   ($00, $00, $00, $00, $FF, $FF, $FF, $FF), {#220}
   ($F0, $F0, $F0, $F0, $F0, $F0, $F0, $F0), {#221}
   ($0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F), {#222}
   ($FF, $FF, $FF, $FF, $00, $00, $00, $00), {#223}
   ($00, $00, $3B, $6E, $64, $6E, $3B, $00), {#224}
   ($00, $3C, $66, $7C, $66, $7C, $60, $60), {#225}
   ($00, $7E, $66, $60, $60, $60, $60, $00), {#226}
   ($00, $7F, $36, $36, $36, $36, $36, $00), {#227}
   ($7E, $66, $30, $18, $30, $66, $7E, $00), {#228}
   ($00, $00, $3F, $6C, $6C, $6C, $38, $00), {#229}
   ($00, $33, $33, $33, $33, $3E, $30, $60), {#230}
   ($00, $3B, $6E, $0C, $0C, $0C, $0C, $00), {#231}
   ($7E, $18, $3C, $66, $66, $3C, $18, $7E), {#232}
   ($1C, $36, $63, $7F, $63, $36, $1C, $00), {#233}
   ($1C, $36, $63, $63, $36, $36, $77, $00), {#234}
   ($0E, $18, $0C, $3E, $66, $66, $3C, $00), {#235}
   ($00, $00, $7E, $DB, $DB, $7E, $00, $00), {#236}
   ($06, $0C, $7E, $DB, $DB, $7E, $60, $C0), {#237}
   ($1C, $60, $C0, $FC, $C0, $60, $1C, $00), {#238}
   ($3C, $66, $66, $66, $66, $66, $66, $00), {#239}
   ($00, $7E, $00, $7E, $00, $7E, $00, $00), {#240}
   ($18, $18, $7E, $18, $18, $00, $7E, $00), {#241}
   ($30, $18, $0C, $18, $30, $00, $7E, $00), {#242}
   ($0C, $18, $30, $18, $0C, $00, $7E, $00), {#243}
   ($0E, $1B, $1B, $18, $18, $18, $18, $18), {#244}
   ($18, $18, $18, $18, $18, $D8, $D8, $70), {#245}
   ($18, $18, $00, $7E, $00, $18, $18, $00), {#246}
   ($00, $76, $DC, $00, $76, $DC, $00, $00), {#247}
   ($38, $6C, $6C, $38, $00, $00, $00, $00), {#248}
   ($00, $00, $00, $18, $18, $00, $00, $00), {#249}
   ($00, $00, $00, $00, $18, $00, $00, $00), {#250}
   ($0F, $0C, $0C, $0C, $EC, $6C, $3C, $1C), {#251}
   ($78, $6C, $6C, $6C, $6C, $00, $00, $00), {#252}
   ($70, $18, $30, $60, $78, $00, $00, $00), {#253}
   ($00, $00, $3C, $3C, $3C, $3C, $00, $00), {#254}
   ($00, $00, $00, $00, $00, $00, $00, $00));{#255}

CONST
  TestInt1FNew: BOOLEAN = FALSE;

VAR
  Int1FSave,
  Int1FNew    : POINTER;


PROCEDURE InitGraph (GraphDriver,
                     GraphMode   : INTEGER;
                     PathToDriver: STRING);
PROCEDURE SetGraphMode(mode: INTEGER);
PROCEDURE CloseGraph;
PROCEDURE RestoreCrtMode;
PROCEDURE TextMode (mode: INTEGER);

IMPLEMENTATION

USES
  Dos,
  Crt,
  Graph;

{$F+}
PROCEDURE SetGrafTabl(VAR Int1FSave: POINTER;
                      VAR SetPtr:    BOOLEAN);
BEGIN
  IF NOT TestInt1FNew THEN
  BEGIN
    SetPtr := FALSE;
    GetIntVec($1F, Int1FSave);    {alten Interr.-Vektor holen }
    IF Seg(Int1FSave^) = 0 THEN   {Grafik-ZS nicht installiert}
    BEGIN
      SetIntVec($1F, @GrafTable); {Interrupt-Vektor $1F  }
      SetPtr := TRUE;             {und Testvariable setzen }
    END;
  END;
END;
{$F-}

PROCEDURE Restore1F;
BEGIN
  IF TestInt1FNew THEN                          { wenn umgeleitet ... }
    SetIntVec($1F, Int1FSave);                  { Zeiger zurcksetzen }
  TestInt1FNew := FALSE;           { Zeiger ist nicht mehr umgeleitet }
END;

(*-------------------------------------------------------------------*)
(*                        Initialisierung:                           *)
(*-------------------------------------------------------------------*)

PROCEDURE InitGraph (GraphDriver,
                     GraphMode:    INTEGER;
                     PathToDriver: STRING);
BEGIN
  SetGrafTabl(Int1FSave, TestInt1FNew);
  Graph.InitGraph(GraphDriver, GraphMode, PathToDriver);
END;

PROCEDURE SetGraphMode(mode: INTEGER);
BEGIN
  SetGrafTabl(Int1FSave, TestInt1FNew);
  Graph.SetGraphMode(mode);
END;

(*-------------------------------------------------------------------*)
(*                    Restaurierungsprozeduren:                      *)
(*-------------------------------------------------------------------*)

PROCEDURE CloseGraph;
BEGIN
 Graph.CloseGraph;
 Restore1F;
END;

PROCEDURE RestoreCrtMode;
BEGIN
  Graph.RestoreCrtMode;
  Restore1F;
END;

PROCEDURE TextMode(mode: INTEGER);
BEGIN
  Crt.TextMode(mode);
  Restore1F;
END;


END.

(*===================================================================*)